/*
	Write & edit by Linjianghua
	Copyright 2006 Linjianghua
	Reserve all right of this file
*/

#include "normlib.def"

extern const char memblkcmp[];

char extCom[32];
char *numbcode(char *chs)
{
  char ch;
  int i;
  for(i=0;(ch=chs[i])>47&&ch<58||ch=='-'||ch=='+';i++);
  return chs+i;
}

char *ReadComs(char *buffers,int *Len)
{
char chr, *buf1, *buf2, *pt, *ptr;
int i, j, b, n1=0, n2=0, t1, t2, msg=0,
    len=strlen(buffers)+1;/* len is useful, don't change its value easily */
    buf1=(char *)malloc(2*len+2);
    buf2=buf1+len+1; *Len=len+1;
    while(*buffers==32||*buffers==9)buffers++;
    pt=buffers;
    for(i=0,b=0;i<len;i++){ chr=buffers[i];
	if(memchr(memblkcmp,chr,5)){
	  ptr=numbcode(pt);
	  t1=ptr-pt;
	  t2= i-b -t1;
	  if(msg){
		msg=0;
		for(j=0;j<=t2;j++)buf2[n2++]=ptr[j];
		for(j=0;j<t1;j++)buf1[n1++]=pt[j];
		buf1[n1++]=chr;
		}
	  else {
		buf2[n2-1]=chr;
		buf1[n1-1]=chr;
		}
	b=i+1;	pt=buffers+b;
    	}
       else msg=1;
    }
return buf1;
}

char **SetArgv(char *src,char *fmt,int *n)
{
  int i, lmt=*n, j=1,
  len=FmtInput(src,n,fmt,32);
  char **pm;
  if(lmt>*n)lmt=*n;
  pm=(char **)malloc( lmt * 4 + 4 );
  *pm=src; pm[lmt]=NULL;
  for(i=0; i<len&&j<lmt; i++)if(src[i]==32){
    pm[j++]=src+i+1;
    src[i]=0;
  }
  return pm;
}

int JxExtName(char comchr,char *compfmt)
{
int i;
for(i=0;compfmt[i];i++)if(compfmt[i]==comchr)return i;
return -1;
}

size_t RemTok(char *input)
{
static const char remDf[6]={13,10,9,32,'='};
char *pt=input, *ptr;
int tms;
for(tms=0;tms<2;tms++){
  while(pt){
     if(tms==0)pt=strstr(pt,"//");
     else {
	pt=strstrcs(pt,"rem ");
	if(pt &&
		pt!=input&&memchr(remDf,pt[-1],6)==NULL){
			pt++; continue;
			}
	}
     if(pt){
	ptr=strchr(pt,'\n');
	if(ptr)memmove(pt,ptr,strlen(ptr)+1);
	else { *pt=0; break; }
    }
  }
  pt=input;
}
return input? strlen(input):0;
}

_Int GetComm(char *buf,char *comchs,_Int *kval)
{
_Int rt=-400;
if(*buf){
  int n, len;
  static const char memblk[4]={ 13,10,',' };
  char *pt, chr, *pext, *pchr=strchrs(buf," \\");
  if(pchr){ chr=*pchr; *pchr=0; }
  pext=strchr(buf,'.');
  if(pext){
	len=strlen(pext);
	if(len>30)len=30;
	*pext=0;
	memcpy(extCom,pext+1,len);
	}
  else memset(extCom,0,32);
  len=strlen(buf);  pt=comchs;
 rechk: pt=strstrcs(pt,buf);
  if(pt){
    if( memchr(memblk,pt[len],4) &&
       (pt==comchs||strchr(memblk,pt[-1])) ){
	n=0;
	while(pt>comchs)if(strchr(memblk,*(--pt) ) )n++;
	rt=kval[n];
    }
    else { pt++; goto rechk; }
  }
  if(pchr)*pchr=chr; 
  if(pext)*pext='.';
}
  return rt;
}

char rwExt[]="cilbwdCILm"; /* m that is  Cvt  special byte  as michine \0 */
_Int siz[INTS_CNT]={1,2,4,1,2,4,1,2,4};
bool IsInts(MAU *pdat,char *buf,_Int wMode)
{
_Int cn, sz, tal;
int n;
static const _Int len[INTS_CNT]={5,4,5,  5,5,6,  5,4,4 };
static const char TypeStr[INTS_CNT][7]={"char:","int:","long:","BYTE:","WORD:","DWORD:",
"Hex8:", "Hex16:", "Hex32:"};
char *pt;
bool noUse=false;
if(wMode>-1){ pt=buf; cn=wMode; goto skp; }
for(cn=0;cn<INTS_CNT;cn++)
    if((pt=strstr(buf,TypeStr[cn]))==buf){ 
	pt+=len[cn]; 
skp:	sz=siz[cn];
	FmtInput(pt, &n, ",;\n\r", ',');
	IsRemChs(pt,&noUse,0); 
	pdat->buf=(char *)atoi_lst(pt,&tal,cn/* t */);
	pdat->len=tal*sz;
	return true;
	}
return false;
}

union Cvt {
_Long lVar;
_Int iVar;
char ch;
};

union uCvt {
unsigned _Long lVar;
un_Int iVar;
BYTE ch;
};

BYTE intType[INTS_CNT]={1,2,4,1,2,4,1,2,4};
char CvtFmt[INTS_CNT][5]={"%d,", "%d,", "%ld,","%u,", "%u,", "%lu,",
	"%x,", "%x,", "%lx," };

void showdat(MAU *send,_Int rMode)
{
int intcnt, j, s, un;
char *pt=send->buf, *buf;
if(pt){
  union Cvt  cvt;
  union uCvt *pUcvt=(union uCvt *)&cvt;
  if(rMode>-1 && rMode<10){
	s=intType[rMode];
	un=rMode>2&&rMode<6;
	intcnt=send->len/s;

	buf=(char *)malloc(send->len * 5 + 8/* safe */);/* 8bit alloc 4char */
	*buf=0;
	for(j=0;j<intcnt;j++,pt+=s){
		memcpy(&cvt, pt, s);
		sprintf(buf+strlen(buf),CvtFmt[rMode], un? (s>1? (s>2? pUcvt->lVar : pUcvt->iVar) : pUcvt->ch) : 
		(s>1? (s>2? cvt.lVar : cvt.iVar) : cvt.ch) );
		}
	buf[strlen(buf)-1]=0; /* rem end(,) */
	pt=buf;
	}
	puts(pt);
	if(rMode>-1&&rMode<=INTS_CNT)free(pt);
  }
}

void *atoi_lst(char *dat, _Int *tol, int type)
{
/* define intType 0-9: char int _Long BYTE size_t DWOED, and hex(6) */
int n=0x7ff0, i, siz;
void *rt;
long var;
static char memblk[6]={ 13,10,32, ',' , 9 };
char *pfree, *val, *pt=strdup(dat);
if(type>11)type=1;/* if type error define, than is int */
siz=intType[type];
RemTok(pt);
/* cvt ' ' to ',' can fmt string, so input freely */
FmtInput(pt, &n, memblk, ',');/* rem: like ,, */
*tol=n;
rt=malloc( siz * n + 4 );
pfree=dat=pt;
val=(char *)rt;
for(i=0;i<n;dat++)if(*dat==','||*dat==0/*memchr(chrs,*dat,4)*/){
    *dat=0;
    sscanf(pt, CvtFmt[type], &var);
    switch(type){
    case 6 :
    case 3 :
    case 0 : *val=var; break;
    case 7 :
    case 4 :
    case 1 : *(_Int *)val=var; break;/* !! ensure 16 bit, must (_Int *) */
    case 8 : 
    case 5 :
    case 2 : *(_Long *)val=var; break;
	}
    val+=siz;    pt=dat+1;  i++;
  }
memset(val,0,siz);
free(pfree);
return rt;
}
