/*
  Designed by LinJiangHua(xempo) 2003-2006
  Copyright 2004-2006,2008,2009 Linjianghua(xempo).
  All Rights Reserve.
*/

#include "sbl.def"

char p_DirFlags[]="\\";

void LDirCvt(_SBL *pblk, SBLdir *Dir)
{
int msg=Dir->Msg;
  if(pblk->Ver>2){
    Dir->dau=msg;
    Dir->statLen= (Dir->datelog? 9:5) + msg * sizeof(DAU);
  }
  else { 
    Dir->dau=msg>sg_dat? 2:1;
    Dir->datelog=(msg-5)%8;
    Dir->statLen=msg;
  }
}

SBLdir *DirRead(_SBL *pblk,_Long adr)
{
 if(adr<1)return NULL;
 if(pblk->cDir==NULL||pblk->cDir->pOwn!=adr){
  SBLdir *Dir=LDirAlloc();
/* compact old DIR */
  dkread(pblk,Dir,pblk->DirSize,1,adr);
/* if(Dir->usemsg!=1){ free(Dir); return NULL; }*/ /* unuseful dir */
  LDirCvt(pblk,Dir);
  Dir->flg++;
  if(Dir->flg==0)Dir->flg=2;
  return Dir;
 }
 else return pblk->cDir;
}

void LDirClose(_SBL *pblk,SBLdir *Dir)
{
if(Dir){
   if(Dir->mdf){
	if( (Dir->mdf&8)==0&&Dir->flg>2 )Dir->flg--;
	dkwrite(pblk,Dir,pblk->DirSize,Dir->pOwn);
	}
   free(Dir);
   }
}

void CatchClose(_SBL *sbl,SBLdir *dir)
{
if(dir!=sbl->cDir)LDirClose(sbl,dir);
}

SBLdir *LDirFix(_SBL *pblk, const char *dirnam,_Long pDir)
{/* pDir is unsure dirnam's pOwn,
it's Dir link first adr of this class */
SBLdir *Dir;
while((Dir=DirRead(pblk,pDir))!=NULL){
  pDir=Dir->nx;
  switch(Dir->usemsg){
  case 1 : 
	if(dirnam!=p_DirFlags&&stricmp(Dir->name,dirnam))
	GoOn:	CatchClose(pblk, Dir);
	else return Dir;
	break;
  case 0 : goto GoOn;
  default :
	  if(dirnam==SPC&&Dir->date<pblk->date /* redir */
	  || dirnam==SBLver&&Dir->date>pblk->date)/* unddel */return Dir;
   }
  }
return NULL;
}

SBLdir *_diropen(_SBL *pblk,char *sendnam,int creatmsg)
{/*
creatmsg: 0 is get exist, 1 get path(Parent, often use for create one Dir)
*/
SBLdir *Dir, *cDir;
int Info=1;
_Long adr;
char *pName, *pt, *dirnam;
if(pblk==NULL){ SBLmsg=2; return NULL; }
SBLmsg=0x7fff; cDir=pblk->cDir;
/*------------------ get special path ------------------*/
if(*sendnam=='.'&&sendnam[1]=='.'){
p_dir:	if(cDir==NULL){ SBLmsg=6; return NULL; }
	Dir=DirRead(pblk,cDir->parDir);
	CatchClose(pblk,cDir); cDir=Dir;
	switch((++sendnam)[1]){
	case '.' :  goto p_dir;
	case '\\' : sendnam++;
	case 0 :  sendnam++; break;
	default : SBLmsg=6; return NULL;
	}
}
else if(*sendnam=='.')switch( sendnam[1] ){
		case '\\': sendnam++; /* self-own */
		case 0 : sendnam++;
} /* ------------------- get special path end ----------------- */

if(*sendnam==0)return cDir;
dirnam=strdup(sendnam);
pt=strchr(dirnam,'\\'); pName=NULL;
do{
	if(pt==dirnam){ Info=0; adr=pblk->DirAdr; pName=pt+1; }
	else {	adr=GetAddress(pblk,cDir);
		pName = pName==NULL? dirnam:pt+1;
		}
	if((pt=strchr(pName,'\\'))!=NULL)*pt=0;
	Info++;
	if((Dir=LDirFix(pblk,pName,adr))==NULL){
	  if(pt||creatmsg==false){
		if(*pName)SBLmsg=6;
		err1: CatchClose(pblk,cDir);
		}
	  else Dir=cDir!=pblk->cDir||Info>1? cDir:NULL;/* new Dir's parent */
	break;
	}
	CatchClose(pblk,cDir);	cDir=Dir;
	if(pt==NULL&&creatmsg){ Dir=NULL; SBLmsg=7; goto err1; } 
}while(pt);
free(dirnam);
return Dir;
}

SBLdir *LDirOpen(_SBL *pblk,char *dirnam)
{
SBLdir *Dir=LDirSeek(pblk,dirnam);
if(!Dir && SBLmsg<0x7ffe)popMsg(BinDat[SBLmsg],dirnam,0);
return Dir;
}
