/*
  Designed by LinJiangHua(xempo) 2004-2006,2008,2009
  Copyright 2004-2006,2008,2009 Linjianghua(xempo).
  All Rights Reserve.
*/

#include <bios.h>
#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include "dos.def"
#include "normlib.def"

ComLst comlst;

char *mblk;
unsigned int xdf, selflg,
blksta, blkend, blklen;

static unsigned int Delete(char *pt,unsigned int cn)
{/* return really cut cn */
unsigned int len=strlen(pt);
if(cn>=len){ *pt=0; return len; }
memmove(pt,pt+cn,len+1);
return cn;
}

void Insert(char *sc, const char *in)
{
size_t  ln=strlen(sc), len=strlen(in);
if(ln)memmove(sc+len, sc, ln);
memcpy(sc,in,len);
sc[ln+len]=0;
}

void PrnTxt(int x,int y,int wdth,unsigned char attr,const char *txt)
{
char far *prn=(char far *)(dosVM+(y-1)*160+x*2),
rattr=attr>>4|attr<<4;
unsigned int s, n, blk1, blk2;
bool flg = txt!=NULL;
if(blksta<blkend){ blk1=blksta; blk2=blkend; }
else { blk2=blksta; blk1=blkend; }
for(s=0,n=xdf;s<wdth;s++,n++){
	if(txt[n]&&flg)prn[s*2]=txt[n];
	else { flg=0; prn[s*2]=0; }
	prn[s*2+1]=selflg&&n>=blk1&&n<blk2? rattr:attr;
	}
}

unsigned int Procblk(char *pt,int key)
{
unsigned int blk1, blk2;
if(blksta<blkend){ blk1=blksta; blk2=blkend; }
else { blk2=blksta; blk1=blkend; }
blklen=blk2-blk1;
if(key==CTRL_C||key==CTRL_X){
	if(mblk)free(mblk);
	mblk=(char *)malloc(4+blklen);
	memcpy(mblk,pt+blk1,blklen);
	mblk[blklen]=0;
	}
if(key!=CTRL_C){
	Delete(pt+blk1,blklen);
	selflg=false;
	}
return blk1;
}

static bool GetSelTxt(int KBSTAT,unsigned int idx)
{
bool flg=0;
if(KBSTAT&3){ /* test 0,1 bit */
  if(selflg){ blkend=idx;  flg=2; }
  else {  blksta=idx; selflg=true; flg=1; }
	}
else if(selflg){ selflg=false; flg=2; }
return flg;
}

int Inptext(char *pt,int wdth,_Int *kmsg)
{
#define KGotoxy(pm) gotoxy(pm+1,cy)
static const _Int togSeltxt[5]={LEFT,RIGHT,HOME,END};
int X=wherex()-1, key, cy=wherey(), cx=0, i,
SelStat, KBSTAT, BufIdx;
unsigned int idx=0, szline=0, cn, t;
char far *prn=(char far *)(dosVM+(cy-1)*160+X*2),
 attr=prn[1], ch;
xdf=0;
BufIdx=comlst.BufCn;
PrnTxt(X,cy,wdth,7<<4|1,pt);
cn=strlen(pt);
while(IsBreak(key=bioskey(0),kmsg)){

KBSTAT=bioskey(2);
if(key){
/*  bioskey(0);*/
  szline=cn-idx;
  if(!IsBreak(key,togSeltxt))SelStat=GetSelTxt(KBSTAT,idx);
  switch(key){
  case RIGHT :
	if(idx<cn){
		if(cx+1<wdth)KGotoxy(++cx+X);
		else {  xdf++;	PrnTxt(X,cy,wdth,7<<4|1,pt); }
		idx++;
		}
	break;
  case LEFT :if(idx>0){
left: 	if(cx<1){ xdf--;
		PrnTxt(X,cy,wdth,7<<4|1,pt);
		}
	else KGotoxy(--cx+X);
	idx--;
	if(key!=BKSP)break;
	}
	else break;
  case DEL : 
	if(selflg)goto procsel;
	if(idx<cn){
	del:Delete(pt+idx,1);
	PrnTxt(X,cy,wdth,7<<4|1,pt);
	cn--;
	}
	break;

  case HOME : if(xdf>0){ xdf=0; PrnTxt(X,cy,wdth,7<<4|1,pt); }
		cx=0;	idx=0;	
		KGotoxy(X+cx);
		break;
  case END : if(cn>wdth){ xdf=cn-(wdth-1); cx=wdth-1;
		PrnTxt(X,cy,wdth,7<<4|1,pt);
		}
	   else cx=cn;
	idx=cn;	KGotoxy(X+cx);
	break;
  case BKSP : 
	bksp:if(idx>0)goto left;
		break;
  case UP : if(BufIdx>0){	BufIdx--; goto f3; }
		break;
  case DOWN : if(BufIdx+1<comlst.BufCn){	BufIdx++; goto f3; }
		break;
  case F3 :
	if(comlst.BufCn>0){
	BufIdx=comlst.BufCn-1;
	f3:	for(i=0,t=0;i<comlst.BufLen&&t<BufIdx;i++)
		   if(comlst.ComBuf[i]==0)t++;
	strcpy(pt,comlst.ComBuf+i);
	PrnTxt(X,cy,wdth,7<<4|1,pt);	cn=strlen(pt);
	cx=cn;	szline=0;	idx=cn;
	KGotoxy(X+cn);
	}
	break;
  case CTRL_C : if(selflg)Procblk(pt,key);break;
  case CTRL_X : if(selflg){
		procsel:idx=Procblk(pt,key);
		cn-=blklen;
		if(xdf>idx){ xdf=idx;idx=0; }
		cx=idx;	KGotoxy(cx+X);
		PrnTxt(X,cy,wdth,7<<4|1,pt);
		if(key==BKSP)goto bksp;
		}
	break;
  case CTRL_V : if(mblk){
		if(selflg){ idx=Procblk(pt,key); cn-=blklen; }
		Insert(pt+idx,mblk);
		t=strlen(mblk);
		cn+=t; idx+=t;
		cx=idx-xdf;	selflg=false;
		if(xdf>idx){ xdf=idx; cx=0; }
		else if(cx>=wdth){ xdf+=cx-wdth+1; cx=wdth-1; }
		PrnTxt(X,cy,wdth,7<<4|1,pt);
		KGotoxy(X+cx);
		}
		break;
  default : 
if((ch=key&0xff)!=0){/* unsuppose normal TAB  display here, mem use too more */
	if(selflg){
		idx=Procblk(pt,key);
		cn-=blklen;	cx=idx-xdf;
		if(xdf>idx){ xdf=idx; cx=0; }
		}
	memmove(pt+idx+1,pt+idx,szline+1);
	pt[idx++]=ch;	pt[++cn]=0;
	if(cx+1<wdth)KGotoxy(++cx+X);
	else xdf++;
	PrnTxt(X,cy,wdth,7<<4|1,pt);
	}
	}

	if(!IsBreak(key,togSeltxt)){
		GetSelTxt(KBSTAT,idx);
		if(SelStat)PrnTxt(X,cy,wdth,7<<4|1,pt);
		}

	}
}
  for(cn=0;cn<wdth;cn++)prn[cn*2+1]=attr;
  puts(SPC);
  cn=strlen(pt); i=0;
  while(comlst.BufLen+cn-i>COMLST_BUFF){
	while(comlst.ComBuf[i])i++;
	comlst.BufCn--;	i++;
	}
  if(i>0){
	comlst.BufLen-=i;
	memmove(comlst.ComBuf,comlst.ComBuf+i,comlst.BufLen+1);
   }
  strcpy(comlst.ComBuf+comlst.BufLen,pt);
  comlst.BufLen+=cn+1; comlst.BufCn++;
  selflg=false;
return key;
#undef KGotoxy
}