/*
  Designed by LinJiangHua(xempo) 2003-2006
  Copyright 2004-2006,2008,2009 Linjianghua(xempo).
  All Rights Reserve.
*/

char **usagMsg;

#ifdef _nso_
#include "_kern.c"
#include "_kerndir.c"
#include "calc.c"
#include "calcerr.c"
#else
#include "calc.def"
extern const char SBL_str[];
#endif

#include <time.h>
#include "dircreat.c"
#include "direx.c"
#include "message.c"
#include "commproc.c"

int Diguei;
char *InfoTxt;
const char chsNum[]="Numb:";

char *bGetDate(time_t dt)
{
struct tm *tm1;
static char dtbuf[22];
tm1=localtime(&dt);/* is static data */
sprintf(dtbuf,"%d-%02d-%02d %02d:%02d:%02d",
tm1->tm_year+1900,tm1->tm_mon+1,tm1->tm_mday,tm1->tm_hour,tm1->tm_min,tm1->tm_sec);
return dtbuf;
}

bool IsNumb(char *dat)
{
char chr;
int i;
if(dat==NULL)return false;
for(i=0;(chr=dat[i])!=0&&chr!=32&&(chr=='+'||chr=='-'||(chr>NUMBC_0&&chr<NUMBC_1));i++);
return (chr|32)==32;
}

static SBLdir *DivPath(_SBL *sbl,char *dat,_Long *nmb)
{/* SBLmsg<0x7ffe: no numb string */
SBLmsg=0x7fff;
if(dat){
 SBLdir *dir;
 char *buf=strdup(dat),
 *pt=strrchr(buf,'\\');
 if(pt==NULL)pt=strrchr(buf,'/');
 if(pt){
	*pt++=0;
	dir=LDirOpen(sbl,buf);
	if(dir && !IsNumb(pt))SBLmsg=11;
	else *nmb=atol(pt);
	}
 else {	dir=sbl->cDir;
	if(IsNumb(buf))*nmb=atol(buf);
	else SBLmsg=11;
	}
 free(buf);
 return dir;
}
return sbl->cDir;
}

_SBL *SBLCreat(char *fname,unsigned idx)
{
char buf[34];
time_t tm;
FILE *fp;
_SBL *pblk=SBLalloc();
fp=fopen(fname,"wb+");
if(fp==NULL){
	KShowMsg(fname,usagMsg[1],1);
	return NULL;
	}
strcpy(buf,SBLtag);
if(idx>2)idx=2;
strcpy(pblk->ver,SBLfver[idx]);
strcpy(buf+17,pblk->ver);
*(_Long *)(buf+24)=*(_Long *)_ver[idx];
fwrite(buf,BSlen,1,fp);
*(_Long *)pblk=*(_Long *)(buf+24);

pblk->fsz=BSlen + buf[25] /*_ver[idx][1]*/;
pblk->use=pblk->fsz;
pblk->fname=strdup(fname);
pblk->creatime=time(&tm);
pblk->date=pblk->creatime;
pblk->fpt=fp;
pblk->mdf=1;/* perhan not create dir */
return pblk;
}

_SBL *SBLinstanc(char *fname,_Int brw)
{
_SBL *pblk=NULL;
if(fname){
  pblk=SBLopen(fname,brw);
  if(pblk&&pblk->adr>0)pblk->cDir=DirRead(pblk,pblk->adr);
   }
return pblk;
}

bool isLdFile(MAU *pdat,char *fname)
{
if(strstr(fname,"#include:")!=fname)return false;
pdat->buf=ReadFile(fname+9,(unsigned int *)&pdat->len);
return (pdat->buf!=NULL);
}


void Read(_SBL *sbl,char *chs, bool pure)
{
_Long numb;
SBLdir *dir=DivPath(sbl,chs,&numb);
if(SBLmsg>0x7ffd){
  MAU mau[2];
  memset(mau,0,2*sizeof(MAU));
  if(GetNumb(sbl,dir,numb,mau,mau+1,1)){
	showdat(mau,JxExtName(extCom[0],rwExt));
	if(dir->dau>1)
		showdat(mau+1,JxExtName(extCom[1],rwExt));
	}
}
else if(SBLmsg==11&&!pure)popMsg(BinDat[11],chs,0);
CatchClose(sbl,dir);
}

void ListDir(_SBL *pblk,char *pm,int msg)
{
_Long adr=pblk->cDir? pblk->cDir->pOwn:-1;
unsigned int sz=1, i=2;
SBLdir dirbuf, *dir;

if(pm==NULL||*pm==0){ 
 dir=pblk->cDir;
 if(dir==NULL)goto skp;
}
else if((dir=LDirOpen(pblk,pm))==NULL&&SBLmsg>0x7ffe){
     skp: dirbuf.nx=pblk->DirAdr;
	goto dirloop;
	}

if(dir){
LDirInfo(pblk,dir,2);
dirbuf.nx=dir->subDir; i=0;
dirloop: if(msg>505){/* 505;  523, 524 */
  while(dirbuf.nx>0&&sz>0){
	if(dirbuf.nx!=adr)
		sz=dkread(pblk,&dirbuf,pblk->DirSize,1,dirbuf.nx);
	else dirbuf=*pblk->cDir;
	LDirInfo(pblk,&dirbuf,i);
	}
}
if(msg!=524&&i==0){
  char *segbuf, *Unit;
  dir->nx_seg=dir->hdadr; sz=dir->datelog? 8:4;
  while(dir->nx_seg>0){
    segbuf=(char *)NumbScan(pblk,dir,0/*buf*/,SBL_LIST);

    for(i=0,Unit=segbuf;i<dir->PreAlloc;i++){
	if(Unit[sz]==1)printf("%ld\t%s\n",*(_Long *)Unit,dir->datelog? bGetDate(*(long *)(Unit+4)):SPC);
	Unit+=dir->statLen;
	}
	free(segbuf);
   }
 }
CatchClose(pblk,dir);
 }
}

void putdat(MAU *pdat,char *buf,_Int wMode)
{
if(buf){
char *pt=isLdFile(pdat,buf)? pdat->buf:buf;
if(wMode==12){
	int n;
	pdat->len=FmtInput(pt, &n, "`" ,  0 );
	pdat->buf=pt;
	}
else if(IsInts(pdat,pt,wMode)==false ){
	if(pt==buf)pdat->len=strlen(pt);
	pdat->buf=pt;
	}
   }
}

void PutNumb(_SBL *pblk,SBLdir *dir,_Long nmb,char *buf,char *buf2)
{
MAU pdat, pdat2;
memset(&pdat2,0,sizeof(MAU));
putdat(&pdat,buf,JxExtName(extCom[0],rwExt));
if(dir->dau>1)putdat(&pdat2,buf2,JxExtName(extCom[1],rwExt));
SetNumb(pblk,dir,nmb,&pdat,&pdat2,1);
if(pdat.buf!=buf)free(pdat.buf);
if(dir->dau>1&&pdat2.buf!=buf2)free(pdat2.buf);
}

int Inpdat(char *buf, const char *msg)
{
printf(msg); *buf=0;
#ifdef	_STDIO_H
gets(buf);
return *buf ?  0 : ESC;
#else
return Inptext(buf,81-wherex(),inpkmsg+3);
#endif
}

int Write(_SBL *sbl,int n,char **pms)
{
SBLdir *dir;
char *pm1, *pm2, *CvtNum=*pms;
int key=0;
_Long nmb;
if(n>1){
  dir=DivPath(sbl,CvtNum,&nmb);
  if(SBLmsg<0x7ffd|| !dir )goto noNumb;
  pm1=pms[1];
  if(dir->dau>1){
	pm2=strchr(pm1,32);
	if(pm2)*pm2++=0;
	}
   }
else {
  pm1=(char *)malloc(520);
  pm2=pm1+260;
  if(n==0){
   key=Inpdat(pm1,chsNum);
   if(!IsBreak(key,exitmsg))goto _ignore;
   CvtNum=pm1;
  }
  fmtVal(CvtNum);
  dir=DivPath(sbl,CvtNum,&nmb);
  if(SBLmsg<0x7ffd||!dir){ 
	noNumb:  if(dir)popMsg(BinDat[SBLmsg],CvtNum,0);
		else if(SBLmsg>0x7ffd)puts(BinDat[6]);
	goto _ignore;
	}

  key=Inpdat(pm1,usagMsg[19]);

  if(!IsBreak(key,exitmsg))goto _ignore;

  if(dir->dau>1){
	printf("NEXT ");
	key=Inpdat(pm2,usagMsg[19]);
	if(!IsBreak(key,exitmsg))goto _ignore;
	}
}
/*--------------------------------------*/
PutNumb(sbl,dir,nmb,pm1,pm2);
_ignore: CatchClose(sbl,dir);
if(n<2)free(pm1);
return key;
}

void numbcopy(_SBL *sbl,char *src,char *dst)
{
MAU mau[2];
char *dat;
_Long srcnmb, dstnmb;
SBLdir *dir=DivPath(sbl,src,&srcnmb);
if(dir){
  if(SBLmsg<0x7ffd)goto skp;
  memset(mau,0,2*sizeof(MAU));
  dat=GetNumb(sbl,dir,srcnmb,mau,mau+1,1);
  CatchClose(sbl,dir);
  if(dat){
    dstnmb=srcnmb;
    if((dir=LDirSeek(sbl,dst))==NULL)dir=DivPath(sbl,dst,&dstnmb);
    if(dir){
	if(SBLmsg<0x7ffd)  skp:   puts(usagMsg[SBLmsg]);
	else SetNumb(sbl,dir,dstnmb,mau,mau+1,1);
	CatchClose(sbl,dir);
	}
     }
   }
}

bool PureNumb(_SBL *sbl,const char *dat)
{
static const _Int IgoreMsg[6]={0x7fff, 6, 5, 4, 2, 0 };
int len, b;
char *pcom, *pm[2], *pt=strdup(dat), *ptr;
b=fmtVal(pt);
pcom=strchr(pt,32);
len=pcom? pcom-pt:b;
if((ptr=(char *)memchr(pt,'=',len))!=NULL){
   if(ptr[1]==0){
	*ptr=0; printf("%s is Empty",pt);
	}
   *ptr++=0;
   *pm=pt;  pm[1]=ptr;
   Write(sbl,2,pm);
	}
else Read(sbl,pt, true);
free(pt);
return !IsBreak(SBLmsg,IgoreMsg);
}

void MoveDir(_SBL *sbl,char *srcname,char *dstname)
{
SBLdir *dir, *dstdir, *orgpdir=NULL, *dirbuf;
_Long adr, pos;
dir=LDirOpen(sbl,srcname);
if(IsInPath(sbl,dir,sbl->cDir)){
	CatchClose(sbl,dir);
	puts(usagMsg[17]);
	return;
	}
if(dir){
  dstdir=LDirOpen(sbl,dstname);
  if(SBLmsg>0x7ffd){
    if(dir->parDir){
	orgpdir=DirRead(sbl,dir->parDir);
	adr=orgpdir->subDir;
	orgpdir->dircnt--;
	}
    else { adr=sbl->DirAdr; sbl->rootcn--; }
  if(dstdir&&dstdir->pOwn==dir->pOwn){
	CatchClose(sbl,dstdir);	CatchClose(sbl,dir);
	puts(usagMsg[7]);
	return;
	}
    pos=0;
    while(adr>0){
	dirbuf=DirRead(sbl,adr);
	if(dirbuf->usemsg==1){
	  if(dirbuf->pOwn==dir->pOwn){
	   if(pos){
		if(pos!=sbl->cDir->pOwn+DirNX)dkwrite(sbl,&dirbuf->nx,4,pos);
		else sbl->cDir->nx=dirbuf->nx;
		}
	   else {
		if(dir->parDir){ orgpdir->subDir=dirbuf->nx; orgpdir->mdf|=1; }
		else sbl->DirAdr=dirbuf->nx;
		}
	   CatchClose(sbl,dirbuf);
	   break;
	  }
	pos=dirbuf->pOwn+DirNX;
	}
	adr=dirbuf->nx;
	CatchClose(sbl,dirbuf);
     }
	CatchClose(sbl,orgpdir);
/* break dir in org */
    adr=dstdir? dstdir->subDir:sbl->DirAdr;
    if(adr==0)dstdir->subDir=dir->pOwn;
    else while(adr>0){	
	dirbuf=DirRead(sbl,adr);
	adr=dirbuf->nx; dirbuf->mdf|=1;
	if(adr==0)dirbuf->nx=dir->pOwn;
	CatchClose(sbl,dirbuf);
     }
	if(dstdir){
	  dstdir->mdf|=1;
	  dstdir->dircnt++;
	  dir->parDir=dstdir->pOwn;
		}
	else { dir->parDir=0; sbl->rootcn++; }
	dir->nx=0;	dir->mdf|=1;
	sbl->mdf|=1;	CatchClose(sbl,dstdir);
	}
  else puts(BinDat[9]);
	CatchClose(sbl,dir);
}
else puts(BinDat[9]);
}

_SBL *AutoBatch(_SBL *sbl,char *fname,_Int *key)
{
if(Diguei<35){
unsigned int sz;
char *buf=ReadFile(fname,&sz);
if(buf){
bool IsRem=false;
char *pt, *buf0=buf, chr=32;
Diguei++;	buf[sz]=0;
while(buf&&*key!=807&&*key!=950/* end */){
      pt=strchrs(buf,"\r\n");
      if(pt){ chr=*pt; *pt++=0; }
      if(*buf&&IsRemChs(buf,&IsRem,chr)==false)sbl=comshell(sbl,buf,key);
      buf=pt;
	}
free(buf0); Diguei--;
if(*key==950)*key=0; /* only exit this script-file */
  }
}
return sbl;
}


int GetParmVal(char *pm,char *fmt)
{
char *ptr=strstr(pm,fmt);
return(ptr ? atoi(ptr+strlen(fmt)) : 0);
}

static char ptNull[]="< None >";
_SBL *comshell(_SBL *sbl,char *pcmd,_Int *kv)
{
static _Int _new[3]={ 801, 810, 820 }; /* create sbl nCom */
_Int rt=0;
int n, cnpm;
_Long numb, pos;
unsigned int i;
_SBL *psbl;
SBLdir *Dir1, *pdir;
char **pms, **lst, *chs;
rt=GetComm(pcmd,ComChs,kvals);
if(rt==-400){
  if(*pcmd && (!sbl || !PureNumb(sbl,pcmd)) ){
	printf(usagMsg[8],pcmd);
	puts(SPC);
	}
}
else {
  if(rt<800&&sbl==NULL){ puts(BinDat[2]); return NULL; }
  switch(rt){
  case 808 : cnpm=2; break;
  case 4 : cnpm=3; break;/* limit only <=3 parm for Write */
  case 509 : if(pcmd[2]=='\\'||pcmd[2]=='.')pcmd[1]=32;
  default : cnpm=20;
  }
  lst=SetArgv(pcmd," \t",&cnpm);
  pms=lst+1; cnpm--;
      switch(rt){
      case 3 : 	
	if(cnpm==0){
		chs=(char *)malloc(320);
		rt=Inpdat(chs,chsNum);
		if(!IsBreak(rt,exitmsg))goto EndRead;
		}
	else chs=*pms;
	Read(sbl,chs, false);
EndRead:	if(cnpm==0)free(chs);
	break;
      case 4 : 	rt=Write(sbl,cnpm,pms);
		break;
      case 22 : 
	switch(cnpm){
	case 0 : puts(usagMsg[4]); break;
	case 1 : puts(usagMsg[10]); break;
	default : numbcopy(sbl,*pms,pms[1]);
	}
	break;
      case 809 : printf(usagMsg[20]);
//		getch();		
		break;
      case 808 :{	double rt=calc(*pms);
	if(n_CalcErr)puts(_calcErr());
	else printf("%lf\n",rt);
	}
	break;
      case 509 :  /*ChDir(sbl,*pms);*/
	if(cnpm==0)puts(usagMsg[5]);
	else {
		Dir1=LDirOpen(sbl,*pms);
		if(SBLmsg>0x7ffd){
		  if(Dir1!=sbl->cDir)LDirClose(sbl,sbl->cDir);
		  sbl->cDir=Dir1;
		  LDirInfo(sbl,Dir1,4);
		}
	}
	break;
      case 522 :
	i=1; n=8;
	if(cnpm){	int t, b;
	  for(b=1;b<cnpm;b++)
		if((t=GetParmVal(pms[b],"-u:"))>0){ i=t; break; }
	  for(b=1;b<cnpm;b++)
		if((t=GetParmVal(pms[b],"-n:"))>0){ n=t; break; }
	}
	else { puts(usagMsg[5]); goto ex; }
	if((Dir1=LDirCreat(sbl,*pms,i,n))!=NULL){
	  if(sbl->cDir==NULL)sbl->cDir=Dir1;
	  else LDirClose(sbl,Dir1);
	}
	else /*if(SBLmsg<0x7ffe)*/popMsg(BinDat[SBLmsg],*pms,STYLE);
	break;
/*-----------------------------------------------------------------------*/
      case 820 :
      case 810 : /* creat  =>old ver sbl */
      case 801 : for(i=0;_new[i]!=rt;i++);
		if(cnpm==0)printf(usagMsg[18]);
		else {
		pcmd=pms[1];
		if((psbl=SBLCreat(*pms,i))!=NULL){
		   if(sbl)SBLdestory(sbl);
		   if(pcmd==NULL||stricmp(pcmd,"-n"))
			psbl->cDir=LDirCreat(psbl,pcmd? pcmd:(char *)"\\SBL1",1,8);
		   sbl=psbl; goto sbl_info;
		}
		}
		break;
      case 824 : sbl=AutoBatch(sbl,*pms,&rt); break;
      case 802 : 
	if(cnpm==0)puts(usagMsg[18]);
	else if((psbl=SBLinstanc(*pms,1))!=NULL){
		  if(sbl)SBLdestory(sbl);
		  sbl=psbl;	goto sbl_info;
		}
	break;

      case 508 : sbl_info: SBLinfo(sbl); break;
      case 827 : puts(SBLver); break;
      case 818 : puts(ComChs); break;
      case 13 : 
	if(cnpm==0)puts(usagMsg[4]);
	else {
	  Dir1=DivPath(sbl,*pms,&numb);
	  if(SBLmsg==11)goto _err_;
	  if(SBLmsg>0x7ffd){
		if(DelNumb(sbl,Dir1,numb)<0x7ffd)popMsg(BinDat[SBLmsg],*pms,0);
	  }
	  else if(Dir1)_err_: popMsg(BinDat[SBLmsg],*pms,0);
	  CatchClose(sbl,Dir1);
	}
	break;
      case 14 : 
      case 15 : Dir1=cnpm? LDirOpen(sbl,*pms):sbl->cDir; /* rescue */
	if((pos=NumbScan(sbl,Dir1,MSG_NO_NUMB,rt==15? SBL_RESCU:SBL_UNDO))>0){
		FixStat(sbl,Dir1,1,1,pos);
		printf(usagMsg[11],*(long *)ScanBuf);
#ifdef	_STDIO_H
	puts(SPC);
#endif
		}
	else puts(ptNull);
	break;
      case 19 : /* ren */
	switch(cnpm){
	case 0 : puts(usagMsg[4]); break;
	case 1 : puts(usagMsg[10]); break;
	default : numb=atol(pms[1]);
	  Dir1=DivPath(sbl,*pms,&pos);
	  if(SBLmsg>0x7ffd && (pos=NumbScan(sbl,Dir1,pos,SBL_READ))>0 ){
		  if(NumbScan(sbl,Dir1,numb,SBL_READ)<0){
			dkwrite(sbl,&numb,4,pos); goto _close_;
			}
		  else SBLmsg=10; /* dst-numb existed */
		}

	if(SBLmsg!=6)puts(BinDat[SBLmsg!=0x7fff? SBLmsg:4]);
	_close_:  CatchClose(sbl,Dir1);
	}
	break;
      case 527 : 
	switch(cnpm){
	case 0 : puts(usagMsg[5]); break;
	case 1 : puts(usagMsg[6]); break;
	default : LDirModify(sbl,*pms,pms[1]);
	}
	break;
      case 528 : if(cnpm)LDirModify(sbl,*pms,NULL);/* here no limit cnpm can use 10 errmsg*/
		else puts(usagMsg[5]);
	break;
      case 529 : 
	switch(cnpm){
	case 0 : puts(usagMsg[5]); break;
	case 1 : puts(usagMsg[9]); break;
	default : MoveDir(sbl,*pms,pms[1]);
	}
	break;
      case 829 : pcmd=ReadFile(usagMsg[21],&i);
		if(pcmd){ printf(pcmd); free(pcmd); }
		break;
      case 505 :
      case 524 : /* onlydir */
      case 523 : ListDir(sbl,*pms,rt);	break;
      case 533 : /* unddel */
      case 530 :
	SBLmsg=0x7fff;
	pdir=cnpm? LDirOpen(sbl,*pms):sbl->cDir;
	if(SBLmsg<0x7ffe)goto none;
	pos=GetAddress(sbl,pdir);
	if((Dir1=LDirFix(sbl,rt==830&&sbl->Ver>0? SPC:SBLver,pos))!=NULL){
	  RemoveDir(sbl,pdir,Dir1,1);
	  printf(usagMsg[12],Dir1->name);  free(Dir1);
	  CatchClose(sbl,pdir);
	}
	else none:printf(usagMsg[12],ptNull);
	break;
      case 831 : puts(usagMsg[3]); break;
      case 532 : 
	Dir1=cnpm==0? sbl->cDir:LDirOpen(sbl,*pms);
	if(Dir1){ chs=(char *)ReGetDir(sbl,Dir1,1);
	   printf("  %s    %s\n",chs,bGetDate(Dir1->date));
	   free(chs);
	   printf(usagMsg[13]+6,Dir1->cn,Dir1->flg,Dir1->sz);
	   if(sbl->Ver)printf(usagMsg[14],Dir1->dircnt);
	   printf(usagMsg[15],Dir1->dau,Dir1->PreAlloc);
	   CatchClose(sbl,Dir1);
	   }
	}
  *kv=rt;
ex: free(lst);
  }
return sbl;
}
