/*
  Designed by LinJiangHua(xempo) 2003-2006
  Copyright 2004-2006,2008-2010 Linjianghua(xempo).
  All Rights Reserve.
*/

#include "_kern.c"
#include "_kernDir.c"
#include "kern.c"
#include "_create.c"
#include "direx.c"
#include "time.c"
#include "message.c"
#include "calc.h"

#define NumbDel(dys,Dir1,numb)	NumbScan(dys,Dir1,numb,DYSTO_DEL)

union Cvt {
long lVar;
_Int iVar;
char ch;
};

union uCvt {
unsigned long lVar;
un_Int iVar;
BYTE ch;
};

const char rwExt[]="cilbwdCILoOpP", **usagMsg;
/* 'o' is CMenuList Cvt (0), case_sen, so 'o'='O' */
enum rw_Mode { _separa=9, _Separa=10, PKtype=11, PKTYPE=12	};
/*#define ConInp(buf) Inptext(buf,81-wherex(),genkmsg)*/
int Diguei;
const char dfchs[]=" \t", val_dirpm[]="-&,-u,-n,-pre,-y",
/* "-&"="-u";  "-n"="-prestat"  */
browpm[]="-n,-d,-i,-t", cre_fmt[]="-v",
exebin_str[]="Storage Plus 1.5 2006-2010, F1 for commands, F9 fastkey";
int val_dirpmval[5]={ 0,0,1,1,2 };

void typeinfo(const char *fnam, const char *descpt, int *brw)
{
const char **ptrs;
int n, i;
char buf[128], *ptr;
strcpy(buf,plusInfo[12]);
if( (ptr=strchr(buf,32))!=NULL){
	*ptr++=0; fmtVal(ptr); n=atoi(ptr);
	}
ptrs=GetDscpt(buf,n);
if(ptrs[1]!=*ptrs){
	n/=2;
	for(i=0;i<n;i++)if(memstr(descpt,BSlen,ptrs[i],0,3)){
		popMsg(ptrs[n+i],fnam,0);
		*brw=0;	break;
		}
	free((void *)*ptrs);
}
free((void *)ptrs);
}

int Inpdat(char *buf,const char *cap, const int *msg)
{
printf(cap);	*buf=0;
return Inptext(buf,81-wherex(),msg);
}

DIRE *DirOpen(Dysto *lib,const char *dirnam)
{
DIRE *Dir=DirSeek(lib,dirnam);
if(Dir){
   if(Dir!=lib->cDir){
	if(Dir->password && pwdcrc(lib,Dir)==false)return NULL;
	DirInit(lib,Dir);
	}
}
else if(DysMsg<0x7ffe)popMsg(plusInfo[DysMsg],dirnam,0);
return Dir;
}

#define DirExist(msg)	msg>0x7ffd
#define DirNone(msg) 	msg<0x7ffe
static DIRE *DivPath(Dysto *dys,const char *dat,long *nmb)
{/* DysMsg<0x7ffe: no numb string */
DysMsg=0x7fff;
if(dat){
 DIRE *dir;
 char *buf=strdup(dat),
 *pt=strrchr(buf,'\\');
 if(pt==NULL)pt=strrchr(buf, '/');
 if(pt){
	*pt++=0;
	dir=DirOpen(dys,buf);
	if(dir && !IsNumb(pt,false))DysMsg=11;
	else *nmb=atol(pt);
	}
 else {	dir=dys->cDir;
	if(IsNumb(buf,false))*nmb=atol(buf);
	else DysMsg=11;
	}
 free(buf);
 return dir;
}
else return dys->cDir;
}

void numbcopy(Dysto *dys,char *src,char *dst)
{
MAU *mau;
long srcnmb, dstnmb;
DIRE *dir;
if((dir=DivPath(dys,src,&srcnmb))!=NULL){
int dau=dir->dau;
  if(DysMsg<0x7ffe)goto skp;
  mau=MAUalloc(dau);
  GetNumb(dys,dir,srcnmb,mau,dau,1);
  Release(dys,dir);
  if(DysMsg>0x7ffe){
    dstnmb=srcnmb;
    if((dir=DirOpen(dys,dst))==NULL)dir=DivPath(dys,dst,&dstnmb);
    if(dir){
	if(DysMsg<0x7ffe) skp:  ErrStyleOut(usagMsg[DysMsg]);
	else SetNumb(dys,dir,dstnmb,mau,dau,1);
	Release(dys,dir);
	}
     }/* get src numb */
   MAUfree(mau,dau);
   free(mau);
   }
}

Dysto *DysOpen(char *fname,int brw)
{
Dysto *lib=NULL;
if(fname){
lib=Instance(fname,brw);
if(lib&&lib->adr>0){
  DIRE *dir=DirRead(lib,lib->adr);
  DirInit(lib,dir);
  if(RSeekDir(lib,dir,2/* Protent */)==NULL)free(dir);
  else lib->cDir=dir;
	}
   }
return lib;
}

bool IsInts(MAU *pdat,char *buf,int wMode)
{
int cn, sz, n;
static const int len[INTS_CNT]={5,4,5, 5,5,6, 5,6,6 };
static const char TypeStr[INTS_CNT][7]={"char:","int:","long:",
	"BYTE:","WORD:","DWORD:",
	"Hex8:", "Hex16:", "Hex32:" };
char *pt;
if(wMode>-1){ pt=buf; cn=wMode; goto skp; }
for(cn=0;cn<INTS_CNT;cn++)
    if((pt=strstr(buf,TypeStr[cn]))==buf){ 
	pt+=len[cn]; 
skp:	sz=intType[cn];
	pdat->buf=(char *)atoi_lst(pt,&n,cn/* t */);
	pdat->len=n*sz;
	return true;
	}
return false;
}

static const char LE[]="\r\n";
void ShowMAU(MAU *send,int rMode, FILE *Out)
{
/* text void is same effect in read, is defferecnt of input(free write) */
char *pt=send->buf, *buf;
if(pt){
  if(rMode>-1&&rMode<=INTS_CNT){
	union Cvt  cvt;
	union uCvt *pUcvt=(union uCvt *)&cvt;
	int j, len=0,
	s=intType[rMode],
	intcnt=send->len/s;
	buf=(char *)malloc(send->len*5+8);
	for(j=0;j<intcnt;j++){
		memcpy(&cvt, pt+(s*j), s);
		len+=sprintf(buf+len,CvtFmt[rMode],
		rMode>2&&rMode<6 ? (s>1? (s>2? pUcvt->lVar : pUcvt->iVar) : pUcvt->ch) : 
		(s>1? (s>2? cvt.lVar : cvt.iVar) : cvt.ch) );
		}
	fwrite(buf,len-1/* -1: remvoe ',' */,1,Out);
	free(buf);
	goto ex;
	}
  if(rMode==PKtype/* is com:cvt */)fwrite("PK",2,1,Out);
  fwrite(pt,send->len,1,Out);/* the print can display send->len, include 0 */
ex:free(pt);
  fwrite(LE,2,1,Out);
}
}

void Read(Dysto *dys,char *chs,char *outdst,int nCom)
{
long numb;
MAU *pdat;
DIRE *dir=DivPath(dys,chs,&numb);
if(DysMsg>0x7ffe){
  FILE *Out;
  int i, dau=dir->dau;
  pdat=MAUalloc(dau);
  if(nCom!=30&&nCom!=8000/* PureNumb(...) */)
	Out=fopen(outdst? outdst:"Display.txt",outdst? WBR:"ab");
  else Out=stdout;
  if(GetNumb(dys,dir,numb,pdat,dau,1)){
    for(i=0;i<dau;i++)
	ShowMAU(pdat+i, nCom!=32? JxExtName(comExt[i],rwExt):PKTYPE, Out);
    free(pdat);
    if(nCom!=8000){
	if(nCom!=30){ fwrite(LE,2,1,Out);fclose(Out);	}
	}
  }
/* if(nCom==8000)DysMsg=0x7fff; */
}
else if(nCom!=8000&&DysMsg==11)
	popMsg(plusInfo[11],chs,0);
Release(dys,dir);
}

void NumbList(Dysto *dys,DIRE *dir,char *Unit)
{
printf("%-15ld%-15ld%-30s\n",*(long *)Unit,n_DatLen(dir,Unit),
	dir->datelog? DttmCvtStr(*(unsigned long *)(Unit+4), dys->mdf):SPC);
}

int DirList(Dysto *dys,DIRE *dir,void *pm)
{
long *vals=pm;
if(vals[1]||vals[3])DirInfo(dys,dir,2);
if(vals[2]||vals[3])StatLoop(dys,dir,NumbList);
return (vals[2]||vals[3])? -1:(vals[1]? 0:1); /* <0 to continue sub */
}

void ListDir(Dysto *lib,char *pm,long *vals)
{
long adr;
DIRE *dir;
int i;
if((dir=DirOpen(lib,pm))==NULL&&DysMsg>0x7ffd){
	adr=lib->DirAdr;	vals[1]=1;/* true */
	}
for(i=0;i<4;i++)if(vals[i])break;
if(i>3)vals[0]=true;
if(dir){
   adr=dir->subDir;
   if(vals[0]||vals[2]||vals[3])/*DirList(lib,dir,vals);*/
	StatLoop(lib,dir,NumbList);
}
if(vals[1]||vals[2]||vals[3])DirExpr(lib,adr,DirList,vals);
Release(lib,dir);
}

static const char _Include[]="#include:";
void PutNumb(Dysto *lib,DIRE *dir,long nmb,char **buff,int comMsg)
{
int d, i, j, cn=dir->dau, wMode;
bool fLoad;
MAU *mau=MAUalloc(cn), *pdat=mau;
char *buf, *pt;
static char fmt[2];
for(i=0, d=0;i<cn&&buff[i];i++,d++, pdat++){
  fLoad=false;
  wMode=JxExtName(comExt[d],rwExt);
  buf=buff[i];

  if(comMsg==41){ pt=buf;	fLoad=true; }
  else if(strstr(buf,_Include)==buf){
	pt=buf+sizeof(_Include)-1; fLoad=true;
	}
  if(fLoad && (pt=ReadFile(pt,(unsigned int *)&pdat->len,false))!=NULL){
	if(wMode==PKTYPE||wMode==PKtype){ pdat->len-=2; memmove(pt,pt+2,pdat->len);  }
	pdat->buf=pt;
	}
  else pt=buf;
  switch(wMode){
  case _separa :
  case _Separa: *fmt=comExt[++d];
	pdat->len=FmtInput(pt, NULL, fmt, 0);
	pdat->buf=pt;
  case PKTYPE : 
  case PKtype : break;
  default : if(IsInts(pdat,pt,wMode)==false){
		if(pt==buf)pdat->len=strlen(pt);
		pdat->buf=pt;
		}
	}
  }
SetNumb(lib,dir,nmb,mau,cn,1);
for(j=0; j<i; j++)
   if(mau[j].buf!=buff[j])free(mau[j].buf);
free(mau);
}

int Write(Dysto *dys,int n,char **pms,int nCom)
{
DIRE *dir;
char **parm, *pdir;
int i, key, cn;
long nmb;
switch(n){
case 0 : 
  pdir=ConBuf;
  key=Inpdat(pdir,"Numb:",genkmsg);
  if(isdone(key,exitmsg))return key;
  fmtVal(pdir);
default :
  dir=DivPath(dys,n? *pms:pdir,&nmb);
  if(DirNone(DysMsg))return 0;
  cn=dir->dau;
  i=cn*sizeof(char **);
}
if(n<2){
  parm=(char **)zalloc(i);
  for(i=0;i<cn;i++){
	key=Inpdat(ConBuf,usagMsg[19],genkmsg);
	if(isdone(key,exitmsg))goto ex;
	else {  if(ConBuf[0]==0)break;
		parm[i]=strdup(ConBuf); }
	}
}
else parm=SetArgv(pms[1],&cn,dfchs);

PutNumb(dys,dir,nmb,parm,nCom);
Release(dys,dir);
key=0;  /* for normal return */
ex: if(n<2)for(i=0;i<cn;i++)if(parm[i])free(parm[i]);
free(parm);
return key;
}

bool PureNumb(Dysto *dys,const char *dat)
{
static const int IgnoreMsg[7]={0x7fff, 6, 5, 4, 2 };
int len, b;
char *pt, *pm[2], *pcom, *ptr;
pt=strdup(dat);
b=fmtVal(pt);
pcom=strchr(pt,32);
len=pcom? pcom-pt:b;
if((ptr=memchr(pt,'=',len))!=NULL){
   if(ptr[1]==0){ *ptr=0; printf("%s is Empty",pt); }
   *ptr++=0;
   *pm=pt;  pm[1]=ptr;
   Write(dys,2,pm,40);
	}
else Read(dys,pt,NULL,8000);
free(pt);
return isdone(DysMsg,IgnoreMsg);
}

void MoveDir(Dysto *dys,char *srcname,char *dstname)
{
DIRE *dir, *dstdir, *orgpdir=NULL, *dirbuf;
long adr, pos;
dir=DirOpen(dys,srcname);
if(IsInPath(dys,dir,dys->cDir)){
	Release(dys,dir);
	ErrStyleOut(usagMsg[17]);
	return;
	}
if(dir){
  dstdir=DirOpen(dys,dstname);
  if(DysMsg>0x7ffd){
    if(dir->parDir){
	orgpdir=DirRead(dys,dir->parDir);
	adr=orgpdir->subDir;
	orgpdir->dircnt--;
	}
    else { adr=dys->DirAdr; dys->rootcn--; }
  if(dstdir&&dstdir->selfaddr==dir->selfaddr){
	Release(dys,dstdir);	Release(dys,dir);
	ErrStyleOut(usagMsg[7]);
	return;
	}
    pos=0;/*adr+DirNX;*/
    while(adr>0){
	dirbuf=DirRead(dys,adr);
	if(dirbuf->usemsg==1){
	  if(dirbuf->selfaddr==dir->selfaddr){
	   if(pos){
		if(pos!=dys->cDir->selfaddr+DirNX)dkwrite(dys,&dirbuf->nx,4,pos);
		else dys->cDir->nx=dirbuf->nx;
		}
	   else {
		if(dir->parDir){ orgpdir->subDir=dirbuf->nx; orgpdir->mdf|=1; }
		else dys->DirAdr=dirbuf->nx;
		}
	   Release(dys,dirbuf);
	   break;
	  }
	pos=dirbuf->selfaddr+DirNX;
	}
	adr=dirbuf->nx;
	Release(dys,dirbuf);
     }
	Release(dys,orgpdir);
/* break dir in org */
    adr=dstdir? dstdir->subDir:dys->DirAdr;
    if(adr==0)dstdir->subDir=dir->selfaddr;
    else while(adr>0){	
	dirbuf=DirRead(dys,adr);
	adr=dirbuf->nx; dirbuf->mdf|=1;
	if(adr==0)dirbuf->nx=dir->selfaddr;
	Release(dys,dirbuf);
     }
	if(dstdir){
	  dstdir->mdf|=1;
	  dstdir->dircnt++;
	  dir->parDir=dstdir->selfaddr;
		}
	else { dir->parDir=0; dys->rootcn++; }
	dir->nx=0;	dir->mdf|=1;
	dys->mdf|=1;	Release(dys,dstdir);
	}
  else ErrStyleOut(plusInfo[9]);
	Release(dys,dir);
}
else ErrStyleOut(plusInfo[9]);
}

Dysto *Execute(Dysto *dys,char *buf,unsigned int sz,int *key)
{
if(buf){
bool IsRem=false;
char *pt, *buf0=buf, chr;
Diguei++;	buf[sz]=0;
do {
      if((pt=strchrs(buf,"\r\n"))!=NULL){ chr=*pt; *pt++=0; }
      if(*buf&&IsRemChs(buf,&IsRem,chr)==false)dys=comshell(dys,buf,key);
}while( (buf=pt)!=NULL&&*key!=807&&*key!=950/* end */&&DysMsg>0x7ffd);
free(buf0); Diguei--;
if(*key==950)*key=0; /* only exit this script-file */
  }
return dys;
}

Dysto *AutoBatch(Dysto *dys,char *fname,int *key)
{
if(Diguei<35){
unsigned int sz;
char *buf=ReadFile(fname,&sz,true);
DysMsg=0x7fff;
dys=Execute(dys,buf,sz,key);
}
return dys;
}

#define MSGCNT 		14
static const char ptNull[]="< None >";
const int coms[MSGCNT]={ 30,31,32,22, 522,819,820,802,13, 19,527,528,529,824 },
msgs[MSGCNT]={4,4,4,4, 5,1,1,18,4, 4,5,5,5,18 };
Dysto *comshell(Dysto *dys,char *pcmd,int *kv)
{
int rt=0, key;
int n, cnpm;
unsigned long pw;
long numb, nmb0, pos, vals[5];
unsigned int i;
MAU *mau;
Dysto *pdys;
DIRE *Dir1, *pdir;
char *chs, **pms, **lst, buf[56], (*pSyb)[4]=(char (*)[4])buf;
rt=GetComm(pcmd,ComChs,kvals);
if(rt==-400){
  if(*pcmd && (!dys||!PureNumb(dys,pcmd)) )printf(usagMsg[21],pcmd);
}
else {
  if(rt<800&&dys==NULL){ ErrStyleOut(plusInfo[2]); return NULL; }
  switch(rt){
  case 922 : 
  case 808 : cnpm=2; break;
  case 41 :
  case 40 : cnpm=3; break;
  case 509 : if(pcmd[2]=='\\'||pcmd[2]=='.')pcmd[1]=32;
  default : cnpm=20;
  }
  lst=SetArgv(pcmd,&cnpm,dfchs);
  pms=lst+1; 
  if(--cnpm==0)
	for(n=0; n<MSGCNT; n++)if(coms[n]==rt){
		ErrStyleOut(usagMsg[msgs[n]]);
		goto ex;
		}
  switch(rt){
  case 922 : if(*pms)puts(*pms);	break;
  case 561 : Dir1=DirRead(dys,dys->DirAdr);
		if(Dir1)DirInit(dys,Dir1);
  case 560 : 
	if(rt==560)Dir1=dys->cDir;
	if(Dir1){
	  n=Dir1->dau; key=rt;
	  mau=MAUalloc(n);
	  if(GetNumb(dys,Dir1,2005,mau,n,true))
		for(i=0;i<n&&DysMsg>0x7ffd;i++)if(mau[i].buf)
			dys=Execute(dys,mau[i].buf,mau[i].len,&rt);
	  free(mau);
	  if(key==561)Release(dys,Dir1);
	}
		break;
  case 32 :
  case 31 :
  case 30 : 	Read(dys,*pms,pms[1],rt);	break;
  case 41 :
  case 40 : 	rt=Write(dys,cnpm,pms,rt);		break;
  case 22 :	if(cnpm==1)ErrStyleOut(usagMsg[10]);
		else numbcopy(dys,*pms,pms[1]);
		break;
  case 808 :{	double rt=calc(*pms);
	if(n_CalcErr)puts(_calcErr());
	else printf("%lf\n",rt);
	}
	break;
  case 809 : printf(usagMsg[20]); bioskey(0); break;
  case 531 : Destory(dys,Rebuild); return NULL;
  case 509 :  /*ChDir(dys,*pms);*/
	     Dir1=DirOpen(dys,*pms);
	     if(DysMsg>0x7ffd){
		 if(Dir1!=dys->cDir)_release(dys,dys->cDir);
		 dys->cDir=Dir1;
		 DirInfo(dys,Dir1,4);
		}
	break;
  case 522 : if(cnpm){
	memset(vals,0,20);
	ParamsCvt(pms,vals,pSyb,val_dirpm,val_dirpmval,1);
	if(vals[0]>0&&dys->verNo<3)vals[0]=(vals[0]>1? 21:13)+(vals[2]? 4:0); 
	switch(cnpm){
	case 1 : break;
	case 3 : if(vals[1]==0)vals[1]=atoi(pms[2]);
	case 2 : if(vals[0]==0)vals[0]=atoi(pms[1]);
	}
	Dir1=DirCreat(dys,*pms,vals[0],vals[1],vals[2]);
	if(Dir1){
	  if(dys->cDir==NULL){ dys->cDir=Dir1; DirInit(dys,Dir1); }
	  else _release(dys,Dir1);
	}
	else /*if(DysMsg<0x7ffe)*/popMsg(plusInfo[DysMsg],*pms,0);
	}
	else ErrStyleOut(usagMsg[8]);
	break;
/*-----------------------------------------------------------------------*/
  case 820 : /* creat */	vals[0]=0;	goto creat_srl;
  case 819 : /* create */vals[0]=VerLmt; /* default is new version */
	creat_srl: ParamsCvt(pms,vals,pSyb,cre_fmt,NULL,1);
	if(access(*pms,0)==0 && KShowMsg(*pms, usagMsg[25],_Quest_|YNE)!='y')break;
	if(dys)Destory(dys,Rebuild);
	if((dys=_Create(*pms,vals[0]))!=NULL)goto dys_info;
	break;
  case 824 : dys=AutoBatch(dys,*pms,&rt); break;
  case 802 :
	pdys=DysOpen(*pms,1);
	if(pdys){
	  if(dys)Destory(dys,Rebuild);
	  dys=pdys;
	  dys_info: DysInfo(dys); 
	}
/*		else if(DysMsg<0x7ffe)ErrStyleOut(plusInfo[DysMsg]);*/
	break;
  case 508 : DysInfo(dys);
	printf("File Path : %s   ID = %d",dys->fname,dys->verNo);
	break;
  case 827 : puts(dysver); break;
  case 818 : puts(ComChs); break;
  case 13 : 
	  Dir1=DivPath(dys,*pms,&numb);
	  if(DirExist(DysMsg))
		NumbDel(dys,Dir1,numb);
	  if(DysMsg<0x7ffd)
		KShowMsg((char *)numb,plusInfo[DysMsg],WrapLine);
	  Release(dys,Dir1);
	break;
  case 14 : 
  case 15 : i=0; pos=0; key=0; n=0;
	if(cnpm){ Dir1=DirOpen(dys,*pms);
		if(DysMsg<0x7ff0)break;
		}
	else Dir1=dys->cDir;
	rescan: i++;
	if((pos=NumbScan(dys,Dir1,pos,DYSTO_RESCU))>0){
	  long pos2;
	  chs=ScanBuf; numb=*(long *)chs;
	  if((pos2=NumbScan(dys,Dir1,numb,DYSTO_READ))>0){
	   if(n!='a')n=KShowMsg((char *)numb,plusInfo[8],_Quest_|YNEA);
	   else goto del_exist;
	   if(n!='y'&&n!='a'){
		if(rt==15)goto cntue;
		else goto abort_reuse;
		}
	   else {
	del_exist: FixStat(dys,Dir1,ScanBuf, -1, pos2);
		free(ScanBuf);
		goto do_undel;
		}
	  }

	  if(key!='a'&&rt==15)
		switch((key=KShowMsg((char *)numb,"reuse %ld ? [y/n/Esc/all]",_Quest_|YNEA))){
		case 27 : free(chs); goto abort_reuse;
		case 'n' : free(chs); cntue: pos++; goto rescan;
		}
	do_undel:  FixStat(dys,Dir1,chs,1,pos);
		/*if Reuse all,then don't retrun ... */
	  free(chs);
	  KShowMsg((char *)numb,usagMsg[11],WrapLine);
	  if(rt==15)goto rescan;
	}
	else if(i<2)puts(ptNull);
	abort_reuse: Release(dys,Dir1);
	break;
  case 510 : dys=Rebuild(dys,NULL); goto dys_info;
  case 515 : if(cnpm)dys->cmprSiz=atol(*pms);
	     else printf("Waste Limit : %u",dys->cmprSiz);
	break;
  case 920 : puts( DttmCvtStr(_CurDate(128),128) ); break;
  case 19 : /* ren */
	if(cnpm==1)ErrStyleOut(usagMsg[10]);
	else { numb=atol(pms[1]);
	  Dir1=DivPath(dys,*pms,&nmb0);
	  if(DysMsg>0x7ffe){
		if((pos=NumbScan(dys,Dir1,nmb0,DYSTO_READ))>0){
			if(NumbScan(dys,Dir1,numb,DYSTO_READ)<1){
			dkwrite(dys,&numb,4,pos);	goto close_dir;
			}
			else DysMsg=10;
		}
		KShowMsg((char *)(DysMsg!=10? nmb0:numb),plusInfo[DysMsg],WrapLine);
	  }
	close_dir:  Release(dys,Dir1);
	}
	break;
      case 527 :
	if(cnpm==1)ErrStyleOut(usagMsg[6]);
	else DirModify(dys,*pms,pms[1]);
	break;
      case 528 : DirModify(dys,*pms,NULL);/* here no limit cnpm can use 10 errmsg*/
		break;
      case 529 : 
	if(cnpm==1)ErrStyleOut(usagMsg[5+cnpm*4]);
	else MoveDir(dys,*pms,pms[1]);
		break;
      case 2 : 
	if(dys->verNo>1 && (Dir1=dys->cDir)!=NULL){
		if((pw=PassWord(Dir1))!=1/* 1=ESC */){
			Dir1->password=pw;	Dir1->mdf|=1;
			Dir1->pwdchr=Dir1->tmpchr;
			if(pw==0)Dir1->realtime=0;
			}
		}
	else ErrStyleOut(usagMsg[22]);
	break;
/*      case 858 : memset(vals,0,12); memset(buf,0,56);
		ParmsCvt(pms,vals,pSyb,TimeTag,NULL,1);
		for(i=0;i<3;i++)if(vals[i])
		switch(i){
		case 0 : printf("CRC Time %s %s\n",pSyb[0],
		*pSyb[0]==':'?(char *)vals[0]:cc_Time(vals[0])); break;
		case 1 : 
			printf("CRC Date %s %s\n",pSyb[1],
		*pSyb[1]==':'?(char *)vals[1]:cc_Date(vals[1])); break;
		case 2 : printf("FullDate %s %s\n",pSyb[2],DttmCvtStr(vals[2]));
		}
		break;*/
      case 829 : pcmd=ReadFile(usagMsg[23],&i,true);
		if(pcmd){ printf(pcmd); free(pcmd); }
		break;
      case 523 : memset(vals,0,16);
	if(cnpm)ParamsCvt(pms,vals,pSyb,browpm,NULL/*browpmval*/,1);
	ListDir(dys,*pms,vals);	break;
      case 533 : /* unddel */
      case 530 :
	DysMsg=0x7fff;
	pdir=cnpm? DirOpen(dys,*pms):dys->cDir;
	if(DysMsg<0x7ffe)goto none;
	pos=GetAddress(dys,pdir);
	Dir1=DirFix(dys,rt==830&&dys->verNo>0? SPC:dysver,pos);
	if(Dir1){
	  RemoveDir(dys,pdir,Dir1,1);
	  printf(usagMsg[12],Dir1->name);  free(Dir1);
	  Release(dys,pdir);
	}
	else none:printf(usagMsg[12],ptNull);
	break;
      case 831 : puts(usagMsg[3]); break;
      case 532 :
	Dir1=cnpm==0? dys->cDir:DirOpen(dys,*pms);
	if(Dir1){	chs=RSeekDir(dys,Dir1,1);
	   printf("  %s    %s\n",chs,DttmCvtStr(Dir1->date,dys->mdf));
		free(chs);
	   printf(usagMsg[13]+6,Dir1->cn,Dir1->sz);
	   if(dys->verNo)printf(usagMsg[14],Dir1->dircnt);
	   printf("DAU:%d%s",Dir1->dau,Dir1->datelog? "(tm)":SPC);
	   printf("  Pre-alloc:%d\n",Dir1->PreAlloc);
	   Release(dys,Dir1);
	   }
	}
  *kv=rt;
ex: free(lst);
  }
return dys;
}